varying lowp vec4       v_colorAdd;                     // output color from vertex shader
varying lowp vec4       v_colorMult;                    // output color from vertex shader
varying mediump vec2    v_texcoord;                     // output texcoord from vertex shader

uniform lowp sampler2D  u_texture;                      // texture

uniform lowp vec4 u_options;       // x = grey scale

void main()
{
    mediump vec4 final_color = v_colorAdd + v_colorMult * texture2D(u_texture, v_texcoord.xy);;
    
    lowp float grey = (final_color.r + final_color.g + final_color.b) / 3.0;
    
    final_color.rgb = (final_color.rgb * (1.0 - u_options.x)) + (vec3(grey, grey, grey) * u_options.x);
    
    gl_FragColor = final_color;
}
