attribute vec4 a_vtx;
attribute lowp vec4 a_color;            // input vtx color from vertex data
attribute mediump vec2 a_Texcoord;      // input tex coord from vertex data

varying lowp vec4 v_colorAdd;           // output vertex color
varying lowp vec4 v_colorMult;          // output vertex color
varying mediump vec2 v_texcoord;        // output tex coord

uniform mat4 u_view2Clip;       // view to clip matrix
uniform mat4 u_Local2View;      // local to view matrix
//uniform vec2 u_fogParam;        // x = (far dist/distance of fog) + enable fog ? 0 : 1000, y = 1/distance of fog
//uniform lowp vec4 u_fogColor;                     // fog color
uniform lowp vec4 u_ambientColor;
uniform lowp vec4 vtx_color_blend_mode;           // color blending function (0.0f = v_color * texture color, 1.0f = v_color)

void main()
{
    vec4 positionV = u_Local2View * a_vtx;
//    if (positionV.z < 0.0) {
//        float fZOffset = (1000.0 + positionV.z) * 0.015;
//        positionV.y -= fZOffset * fZOffset;
//    }
	// we can calculate fog in vertex shader because this is 2d shader. positionV.z must be constant.
   // mediump float fFogFactor = clamp(u_fogParam.x + positionV.z * u_fogParam.y, 0.0, 1.0);
	v_colorAdd  = vtx_color_blend_mode*a_color;
	//v_colorAdd.rgb += (1.0-fFogFactor)*u_fogColor.rgb;
//    v_colorAdd.rgb += u_ambientColor.a*u_ambientColor.rgb;
    
	v_colorMult = (1.0 - vtx_color_blend_mode)*a_color;
	//v_colorMult.rgb *= fFogFactor;
    v_colorMult.rgb *= clamp(u_ambientColor.a * u_ambientColor.rgb, 0.0, 1.0);
    v_texcoord  = a_Texcoord;
    gl_Position = u_view2Clip * positionV;
}
